$regfile = "attiny2313.dat"                                 'procesor ATTiny2313
$crystal = 1000000                                          'oscylator wewntrzny
Config Portb = Output                                       'katody wywietlaczy
Config Pind.6 = Output                                      'setki
Config Pind.4 = Output                                      'dziesitki
Config Pind.5 = Output                                      'jednoci
Config Pind.3 = Output                                      'dioda LED
Config Pind.0 = Output                                      'goniczek
Config Pind.1 = Output                                      'nieuywane wyprowadzenie
Config Pina.1 = Input                                       'switch S3 - zmiana tonu
Config Pina.0 = Input                                       'switch S2 - BPM --
Config Pind.2 = Input                                       'switch S1 - BPM++

Config Timer0 = Timer , Prescale = 8                        'timer do sterowania wywietlaczami
Config Timer1 = Timer , Prescale = 64                       'timer do odliczania przerw
Declare Sub Cyfry                                           'podprogram rozbijajcy liczb na cyfry
Declare Sub Czas                                            'podprogram obliczajcy warto adowan do Timer1
Declare Sub Zakres                                          'podprogram kontrolujcy zakres BPM
On Timer0 Wyswietlaj                                        'przerwanie od Timer0 powoduje skok do Tyswietlaj
On Timer1 Dzwiek                                            'przerwanie od Timer1 powoduje skok do Dzwiek
Dim Setki As Byte                                           'cyfra setek
Dim Dziesiatki As Byte                                      'cyfra dziesitek
Dim Jednosci As Byte                                        'cyfra jednoci
Dim Nr_wysw As Byte                                         'numer uruchomionego wywietlacza
Dim Bpm As Byte                                             'BPM - ilo uderze na minut
Dim Bpm_kopia As Byte                                       'warto BPM, kopiowana na czas oblicze
Dim Ton As Byte                                             'numer wybranego dwiku
Dim Flaga_opoznienia As Bit                                 'odpowiada za podtrzymanie wiecenia wywietlacza
Dim Flaga_timer1 As Bit
Dim Wart_pocz As Word                                       'warto obliczona, adowana do Timer1

Enable Interrupts                                           'uruchamiany przerwania
Load Timer0 , 100                                           'wpisujemy pocztkow warto Timer0

Set Portd.0                                                 'wczamy rezystory podcigajce
Set Portd.1
Set Portd.2
Set Portd.3
Set Portd.4
Set Portd.5
Set Portd.6
Set Porta.1
Set Porta.0

Set Flaga_opoznienia                                        'wygasi automatycznie wywietlacz po pokazaniu wartoci BPM
Reset Flaga_timer1
Readeeprom Bpm , 5                                          'wczytanie z EEPROM wartoci BPM
Readeeprom Ton , 8                                          'wczytanie z EEPROM numeru wybranego dwiku
Zakres                                                      'jeeli odczytata warto bdzie spoza zakresu (np. 0) - skoryguj j
Czas                                                        'przeliczenie wczytanej wartoci BPM na pocztkow warto licznika
Cyfry                                                       'rozbicie liczby BPM na trzy cyfry
Enable Timer0                                               'wczenie Timer0 - pokazanie wczytanej z EEPROM wartoci
Set Flaga_opoznienia                                        'ustawienie flagi - automatycznie wygasi wywietlacz
Load Timer1 , Wart_pocz                                     'zaadowanie do Timer1 obliczonej wartoci
Enable Timer1                                               'uruchomienie Timer1 i rozpocznie "stukania"

Do

If Pind.2 = 0 Then                                          'po naciniciu S1
Disable Timer1                                              'wycz Timer1 - przerwania od niego zakcaj wywietlacz
Set Flaga_opoznienia                                        'ustaw flag, ktra pniej wyczy wywietlacz
Incr Bpm                                                    'zwikszaj warto BPM
Zakres                                                      'sprawdzaj, czy ustalona warto mieci si w zakresie
Cyfry                                                       'rozbicie liczby BPM na trzy cyfry
Enable Timer0                                               'wczenie Timer0 - uruchomienie wywietlacza
Waitms 100                                                  'odczekanie 100ms, by inkrementacja nie bya zbyt szybka
End If


If Pina.0 = 0 Then                                          'po naciniciu S2
Disable Timer1                                              'wycz Timer1 - przerwania od niego zakcaj wywietlacz
Set Flaga_opoznienia                                        'ustaw flag, ktra pniej wyczy wywietlacz
Decr Bpm                                                    'dekrementacja wartoci BPM
Zakres                                                      'sprawdzaj, czy ustalona warto mieci si w zakresie
Cyfry                                                       'rozbicie liczby BPM na trzy cyfry
Enable Timer0                                               'wczenie Timer0 - uruchomienie wywietlacza
Waitms 100                                                  'odczekanie 100ms, by inkrementacja nie bya zbyt szybka
End If


If Pina.1 = 0 Then                                          'po naciniciu S3
Set Flaga_timer1
Disable Timer1                                              'wycz Timer1 - przerwania od niego zakcaj wywietlacz
Incr Ton                                                    'inkrementuj warto zmiennej Ton
If Ton >= 5 Then                                            'jeeli wyszlimy poza zakres...
Ton = 0                                                     '...wr do zera
End If
Setki = 33                                                  'wyczenie cyfry setek
Dziesiatki = Ton                                            'numer dwiku jest na rodkowej cyfrze wywietlacza
Jednosci = 33                                               'wyczenie cyfry jednoci
Enable Timer0                                               'uruchomienie wywietlacza
Wait 1                                                      'odczekanie sekundy, by inkrementacja bya widoczna
End If


'po zwolnieniu wszystkich przyciskw po zmienianej wartoci BPM
If Flaga_opoznienia = 1 And Pina.0 = 1 And Pina.1 = 1 And Pind.2 = 1 Then
Czas                                                        'dokonaj przeliczenia nowej wartoci BPM
Load Timer1 , Wart_pocz                                     'zaaduj j do licznika Timer1
Waitms 750                                                  'odczekaj 3/4 sekundy
Disable Timer0                                              'wycz wywietlacz...
Set Portd.4                                                 '...i wszystkie cyfry
Set Portd.5
Set Portd.6
Writeeeprom Bpm , 5                                         'zapisz now warto do EEPROM
Reset Flaga_opoznienia                                      'wyga flag - spenia swoje zadanie
Enable Timer1                                               'wcz Timer1, czyli rozpocznij "pukanie"
End If


'po zwolnieniu wszystkich przyciskw po zmienianym tonie dwiku
If Flaga_timer1 = 1 And Pina.0 = 1 And Pina.1 = 1 And Pind.2 = 1 Then
Waitms 750                                                  'odczekaj 3/4 sekundy
Disable Timer0                                              'wyczenie wywietlacza
Set Portd.4                                                 'wyczenie anod wywietlaczy
Set Portd.5
Set Portd.6
Enable Timer1                                               'uruchomienie Timer1 - rozpocznie "pukania"
Writeeeprom Ton , 8                                         'zapisanie numeru dwiku do EEPROM
Reset Flaga_timer1                                          'wyga flag
End If

Loop
End


Sub Zakres:                                                 'podprogram sprawdzajcy zakres BPM
If Bpm >= 251 Then                                          'jeeli przekracza 250
Bpm = 30                                                    'ustaw na 30
End If

If Bpm <= 29 Then                                           'jeeli za jest mniejszy ni 30
Bpm = 250                                                   'ustaw na 250
End If
End Sub


Sub Cyfry                                                   'podprogram rozkadajcy liczb BPM na cyfry
Bpm_kopia = Bpm                                             'skopiowanie wartoci BPM
Jednosci = Bpm_kopia Mod 10                                 'wyuskanie cyfry jednoci
Bpm_kopia = Bpm_kopia - Jednosci                            'odjcie jednoci - teraz ostatni cyfr jest zero
Bpm_kopia = Bpm_kopia / 10                                  'podzielenie przez 10
Dziesiatki = Bpm_kopia Mod 10                               'wyuskanie cyfry dziesitek
Bpm_kopia = Bpm_kopia - Dziesiatki                          'jak wyej
Bpm_kopia = Bpm_kopia / 10
Setki = Bpm_kopia                                           'to, co zostao, jest cyfr setek
End Sub


Sub Czas                                                    'podprogram obliczajcy warto pocztkow licznika Timer1
Wart_pocz = 15625 / Bpm                                     'najpierw obliczenie iloci taktw na sekund
Wart_pocz = Wart_pocz * 60                                  'a tu na minut, poprzez mnoenie
End Sub


Dzwiek:                                                     'podprogram obsugujcy przerwanie od Timer1
Select Case Ton:                                            'jeeli zmienna Ton wynosi...
Case 0:                                                     '...zero, to
Sound Portd.0 , 5 , 1500                                    'generuj dwik
Case 1:                                                     'itd.
Sound Portd.0 , 6 , 750
Case 2:
Sound Portd.0 , 7 , 375
Case 3:
Sound Portd.0 , 8 , 182
Case 4:
Sound Portd.0 , 10 , 61
End Select
Reset Portd.3                                               'uruchom diod LED
Waitus 400                                                  'odczekaj krtki odcinek czasu
Set Portd.3                                                 'wycz diod LED
Load Timer1 , Wart_pocz                                     'ponownie zaaduj do Timer1 warto pocztkow
Return


Wyswietlaj:                                                 'wybranie wywietlacza do uruchomienia - za kadym razem nastpnego
Load Timer0 , 100                                           'zaadowanie do Timer0 wartoci pocztkowej
Set Portd.6                                                 'wycz wszystkie wywietlacze
Set Portd.5
Set Portd.4
Select Case Nr_wysw                                         'wczenie jednego wywietlacza

Case 0:                                                     'jeeli Nr_wysw = 0, to
Portb = Lookup(setki , Cyfra)                               'wystaw na PORTB cyfr setek
Reset Portd.6                                               'uruchom cyfr setek

Case 1:                                                     'jeeli Nr_wysw = 1, to
Portb = Lookup(dziesiatki , Cyfra)                          'wystaw na PORTB cyfr dziesitek
Reset Portd.5                                               'uruchom cyfr dziesitek

Case 2:                                                     'jeeli Nr_wysw = 2, to
Portb = Lookup(jednosci , Cyfra)                            'wystaw na PORTB cyfr jednoci
Reset Portd.4                                               'uruchom cyfr jednoci

End Select
Incr Nr_wysw                                                'zwiksz warto
If Nr_wysw = 3 Then                                         'jeeli licznik wywietlaczy si "przekrci"
Nr_wysw = 0                                                 'naley go wyzerowa
End If
Return


Cyfra:                                                      'tablica przechowujca segmenty odpowiadajce danej cyfrze
Data &B10000001 , &B11001111 , &B10010010 , &B10000110 , &B11001100 , &B10100100 , &B10100000 , &B10001111 , &B10000000 , &B10000100